#ifndef __LOADER_H_LSM__
#define __LOADER_H_LSM__

#include "serial.hpp"

#ifndef LOADER_DEFAULT_FILE_NAME 
#define LOADER_DEFAULT_FILE_NAME "test1.s19"
#endif
#ifndef LOADER_DEFAULT_BOOT_NAME 
#define LOADER_DEFAULT_BOOT_NAME "eeprogix.boo"
#endif
#ifndef LOADER_DEFAULT_PORT_NAME 
#define LOADER_DEFAULT_PORT_NAME "COM1"
#endif
#ifndef LOADER_MAX_RETRY	
#define LOADER_MAX_RETRY	300	// read timeout
#endif


#define LOADER_COM_INIT_ERROR	1
#define LOADER_BOOT_FILE_OPEN_ERROR	2
#define LOADER_FLASH_FILE_OPEN_ERROR	3
#define LOADER_BOOT_DOWNLOAD_ERROR	4
#define LOADER_FLASH_DOWNLOAD_ERROR	5

#define LOADER_ERROR		-1
#define	LOADER_SUCCESS		0

#define LOADER_MAX_FILENAME_LENGTH	256


class loaderCL
{
public:
	loaderCL();
	~loaderCL();

	int setBootFileName(char * filename);
	int setFlashFileName(char * filename);
	int setSerialPort(char* portname);
	char * getBootFileName();
	char * getFlashFileName();

	int writeFlash(bool verbose=false);
	int writeFlash(char * flashfilename, bool verbose=false);

private:
	serialCL	serialCom_;
	char portName_[LOADER_MAX_FILENAME_LENGTH];
	char flashFilename_[LOADER_MAX_FILENAME_LENGTH];
	char bootFilename_[LOADER_MAX_FILENAME_LENGTH];
};

#endif